/* $Id: manualaddition.js,v 1.9 2006/07/12 11:23:28 hanifa Exp $ */

/*------------------------------- Common Script functions - Starts ------------------------------*/

function cleanSelectBox(elementid,addNONE)
{
    var elementObj = eval(elementid);
    while(elementObj.length > 0)
    {
        for (var i=0;i<elementObj.length;i++)
        {
            elementObj.options[i] = null;
        }
    }
    
    if (addNONE)
    {
        elementObj.options[0] = new Option('NONE','NONE');
    }
}

/*------------------------------ Common Script functions - Ends ---------------------------------*/


/*------------------- ResourceIdentify Screen related JavaScripts - Starts ----------------------*/

function validateValues_ResourceIdentify()
{
    /*
    parent.VerifyFields = new Array("DEVICE_NAME","DEVICE_IPADDRESS","VENDOR_NAME","DEVICE_TYPE");
    parent.VerifyFields_DisplayNames = new Array("Name","IPAddress","Make","Device Type");
    parent.VerifyFields_Values = new Array(4);
    */
    
    var devicename = "document.NCMAddResourceIdentifyView_FRM.DEVICE_NAME";
    var ipaddress = "document.NCMAddResourceIdentifyView_FRM.DEVICE_IPADDRESS";
    //var vendorname = "document.NCMAddResourceIdentifyView_FRM.VENDOR_NAME";
    //var devicetype = "document.NCMAddResourceIdentifyView_FRM.DEVICE_TYPE";
    
    var result = checkIfTextfieldEmpty(eval(devicename),'Please enter Name of the Device');
    if(!result)
    {
        result = checkIfTextfieldEmpty(eval(ipaddress),'Please enter IPAddress');
    }
    if(!result)
    {
        if(! isValidIPAddress(eval(ipaddress).value) )
        {
            alert("Enter valid IPAddress");
            return;
        }
    }
    
    /*
    parent.VerifyFields_Values[0] = eval(devicename).value;    
    parent.VerifyFields_Values[1] = eval(ipaddress).value;    
    parent.VerifyFields_Values[2] = eval(vendorname).options[(eval(vendorname).selectedIndex)].value; 
    parent.VerifyFields_Values[3] = eval(devicetype).options[(eval(devicetype).selectedIndex)].value; 
    */
   
    return !result;
}


function changeDeviceTypes(selected_devicetype)
{
    var type = "document.NCMAddResourceIdentifyView_FRM.DEVICE_TYPE";
    // Handling the selection of NONE
    if(selected_devicetype == 'NONE')
    {
        cleanSelectBox(type,true);
        return;
    }
    
    // Handling valid Vendor selection
    cleanSelectBox(type,false);
    var re = / /g;
    var spl_devicetype = selected_devicetype.replace(re,"_");
    var devicetypelist = eval("vendor_" + spl_devicetype);
    var devicetypeObj = eval(type);
    devicetypelist.sort();
    for(var i=0;i<devicetypelist.length;i++)
    {
        devicetypeObj.options[i] = new Option(devicetypelist[i], devicetypelist[i]);
    }
}

/*------------------- ResourceIdentify Screen related JavaScripts - Ends ------------------------*/




/*------------------- ResourceClassify Screen related JavaScripts - Starts ----------------------*/

function validateValues_ResourceClassify()
{
    validation_fields = eval("parent.NCMAddResourceClassifyView_FRM_ValidationFields");
    validation_fields_types = eval("parent.NCMAddResourceClassifyView_FRM_ValidationFields_Type");
    validation_fields_display = 
                      eval("parent.NCMAddResourceClassifyView_FRM_ValidationFields_DisplayValue");

	var regexArr = new Array();
	regexArr[0] = /10\.[3-9][\w()]*|11\.[\w()]*/ ;
	regexArr[1] = /1[2-9]\.[0-9\w().]*/;
   
	if(NCMDeviceType == "CiscoSwitch" || NCMDeviceType == "CiscoRouter")
	{
		osVersionValue = document.NCMAddResourceClassifyView_FRM.DEVICE_OSVERSION.value;

		if(!(regexArr[0].test(osVersionValue) || regexArr[1].test(osVersionValue)))
		{
			// if no regex matches return false
			alert("OSVersion value is incorrect. Enter as present in the device");
			return false;
		}
		matchDone = false;
		for(i = 0; i < regexArr.length; i++)
		{

			myarr = regexArr[i].exec(osVersionValue);

			if(myarr != null)
			{
				if(myarr[0] == osVersionValue)
				{
					matchDone = true;
				}
			}

		}
		if(!matchDone)
		{
			alert("OSVersion value doesn't follow required format. Enter as present in the device");
			return false;
		}

	}
	
 
    var result = true;
    for (var i=0;i<validation_fields.length;i++)
    {
        // TODO 
        // Only TEXT type validation is done. For others types, validation needs to be done.
        
        //alert("Validation Field : "+ validation_fields[i] + " Type : " + validation_fields_types[i]);
        field_name = validation_fields[i];
        
        if (validation_fields_types[i] == "TEXT")
        {
            obj = eval("document.NCMAddResourceClassifyView_FRM."+field_name);
            result = checkIfTextfieldEmpty(obj,"Please enter value for the field \'"+
                                           validation_fields_display[i]+"\'");
        }
    }
    
    return !result;
}


function populateSeries_S_R(devicetype)
{
    //alert("Populate Series S_R: "+devicetype);
    var seriesname = "document.NCMAddResourceClassifyView_FRM.DEVICE_SERIES";
    cleanSelectBox(seriesname,false);
    var seriesobj = eval(seriesname);
 
    var re = / /g;
    var spl_devicetype = devicetype.replace(re,"_");
    var serieslist = eval("parent." + "vendor_" + spl_devicetype);
    serieslist.sort();
    for(var i=0;i<serieslist.length;i++)
    {
        if (i == 0)
        {
            seriesobj.options[i] = new Option(serieslist[i],serieslist[i],true);
        }
        else
        {
            seriesobj.options[i] = new Option(serieslist[i],serieslist[i]);
        }
    }
}

function populateModel_S_R(devicetype)
{
    //alert("Populate Model S_R: "+devicetype);
    var seriesname = "document.NCMAddResourceClassifyView_FRM.DEVICE_SERIES";
    var modelname = "document.NCMAddResourceClassifyView_FRM.DEVICE_MODEL";
    
    cleanSelectBox(modelname,false);
    var modelobj = eval(modelname);
    
    var index = eval(seriesname).selectedIndex;
    var selectedseries = eval(seriesname).options[index].value;
    
    var re = / /g;
    var spl_devicetype = devicetype.replace(re,"_");
    var spl_series = selectedseries.replace(re,"_");
    var final_variable = "parent." + "vendor_" + spl_devicetype + "_" + spl_series ;
    
    var modellist = eval(final_variable);
    modellist.sort();
    for(var i=0;i<modellist.length;i++)
    {
        if (i == 0)
        {
            modelobj.options[i] = new Option(modellist[i],modellist[i],true);
        }
        else
        {
            modelobj.options[i] = new Option(modellist[i],modellist[i]);
        }
    }
}

function populateOSType_S_R(devicetype)
{
    //alert("Populate OSType S_R: "+devicetype);
    var seriesname = "document.NCMAddResourceClassifyView_FRM.DEVICE_SERIES";
    var modelname = "document.NCMAddResourceClassifyView_FRM.DEVICE_MODEL";
    var ostypename = "document.NCMAddResourceClassifyView_FRM.DEVICE_OSTYPE";

    cleanSelectBox(ostypename,false);
    var ostypeobj = eval(ostypename);

    var index_series = eval(seriesname).selectedIndex;
    var selectedseries = eval(seriesname).options[index_series].value;
    //alert("Selected Series : "+selectedseries);
    
    var index_model = eval(modelname).selectedIndex;
    var selectedmodel = eval(modelname).options[index_model].value;
    //alert("Selected Model : "+selectedmodel);

    var re = / /g;
    var spl_devicetype = devicetype.replace(re,"_");
    var spl_series = selectedseries.replace(re,"_");
    var spl_model = selectedmodel.replace(re,"_");
    var final_variable = "parent." + "vendor_" + spl_devicetype + "_" + spl_series + "_" + spl_model ;
    
    var ostypelist = eval(final_variable);
    ostypelist.sort();
    for(var i=0;i<ostypelist.length;i++)
    {
        if (i == 0)
        {
            ostypeobj.options[i] = new Option(ostypelist[i],ostypelist[i],true);
        }
        else
        {
            ostypeobj.options[i] = new Option(ostypelist[i],ostypelist[i]);
        }
    }
}

function changeModelAndOSType_S_R(devicetype)
{
    populateModel_S_R(devicetype);
    populateOSType_S_R(devicetype);
}

function changeOSType_S_R(devicetype)
{
    populateOSType_S_R(devicetype);
}

/*------------------- ResourceClassify Screen related JavaScripts - Ends ------------------------*/



